## gl4es 0%2Bv1.1.4%2B153%2Bgc82889c

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(gl4es LANGUAGES C)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/lib)

link_directories(${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

option(PANDORA "Set to ON if targeting an OpenPandora device" ${PANDORA})
option(PYRA "Set to ON if targeting an Dragonbox Pyra device" ${PYRA})
option(BCMHOST "Set to ON if targeting an RPi(2) device" ${BCMHOST})
option(ODROID "Set to ON if targeting an ODroid device" ${ODROID})
option(ANDROID "Set to ON if targeting an Android device" ${ANDROID})
option(CHIP "Set to ON if targeting an C.H.I.P. device" ${CHIP})
option(AMIGAOS4 "Set to ON if targeting an AmigaOS4/Warp3D platform (activate NOEGL and NOX11)" ${AMIGAOS4})
option(NOX11 "Set to ON to not use X11 (creation of context has to be done outside gl4es)" ${NOX11})
option(NOEGL "Set to ON to not use EGL (all functions are taken in GLES library)" ${NOEGL})
option(STATICLIB "Set to ON to build a static version of gl4es" ${STATICLIB})
option(GBM "Set to ON to not build GBM interface" ${GBM})
option(USE_CCACHE "Set to ON to use ccache if present in the system" ${USE_CCACHE})
option(USE_CLOCK "Set to ON to use clock_gettime instead of gttimeofday for LIBGL_FPS" ${USE_CLOCK})
option(NO_LOADER "disable library loader (useful for static library with NOEGL, NOX11, use include/gl4esinit.h)" ${NO_LOADER})
option(NO_INIT_CONSTRUCTOR "disable automatic initialization (useful for static library, use include/gl4esinit.h)" ${NO_INIT_CONSTRUCTOR})

include(CheckSymbolExists)
check_symbol_exists(backtrace "execinfo.h" HAS_BACKTRACE)
if (HAS_BACKTRACE)
    add_definitions(-DHAS_BACKTRACE)
endif()

# Pandora
if(PANDORA)
    add_definitions(-DPANDORA)
    add_definitions(-DTEXSTREAM)
    add_definitions(-mcpu=cortex-a8 -mfpu=neon -mfloat-abi=softfp -ftree-vectorize -fsingle-precision-constant -ffast-math)
    set(NO_GBM ON)
endif()

if((NOT GBM) OR PANDORA)
    set(NO_GBM ON)
else()
    set(NO_GBM OFF)
endif()


if(NOT DEFAULT_ES)
    if(PANDORA)
        set(DEFAULT_ES 1)
    else()
        set(DEFAULT_ES 2)
    endif()
endif()

if(STATICLIB)
    add_definitions(-DSTATICLIB)
endif(STATICLIB)

# Pyra
if(PYRA)
    add_definitions(-DPYRA)
    #add_definitions(-DTEXSTREAM)
    add_definitions(-mcpu=cortex-a15 -mfpu=neon-vfpv4 -mfloat-abi=hard -ftree-vectorize -fsingle-precision-constant -ffast-math)
    set(NO_GBM ON)
endif()

# Raspberry PI
if(BCMHOST)
    include_directories(/opt/vc/include /opt/vc/include/interface/vcos/pthreads /opt/vc/include/interface/vmcs_host/linux)
    link_directories(/opt/vc/lib)
    add_definitions(-DBCMHOST)
endif()

# ODROID
if(ODROID)
    add_definitions(-DODROID)
endif()

# Android
if(ANDROID)
    add_definitions(-DANDROID)
    add_definitions(-DNOX11 -DNO_GBM -DDEFAULT_ES=2)
    find_library(log-lib log)
endif()

#PocketCHIP
if(CHIP)
    add_definitions(-DCHIP)
    add_definitions(-mcpu=cortex-a8 -mfpu=neon -mfloat-abi=hard -ftree-vectorize -fsingle-precision-constant -ffast-math)
endif()

# AmigaOS4
if(AMIGAOS4)
    set(CMAKE_C_COMPILER "ppc-amigaos-gcc")
    set(CMAKE_CXX_COMPILER "ppc-amigaos-g++")
    set(CMAKE_LINKER "ppc-amigaos-ld")
    set(CMAKE_AR "ppc-amigaos-ar")
    set(CMAKE_RANLIB "ppc-amigaos-ranlib")
    add_definitions(-DAMIGAOS4)
    set(NOX11 ON)
    set(NOEGL ON)
    set(NO_GBM ON)
    set(CMAKE_C_FLAGS_DEBUG "-O1 -gstabs")
    set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -gstabs")
endif()

#NOX11
if(NOX11)
    add_definitions(-DEGL_NO_X11)
    add_definitions(-DNOX11)
endif()

#NOEGL
if(NOEGL)
    add_definitions(-DNOEGL)
    add_definitions(-DNOX11)
endif()

if(NOT NO_GBM)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(KMSDRM REQUIRED libdrm gbm egl)
    link_directories(${KMSDRM_LIBRARY_DIRS})
    include_directories(${KMSDRM_INCLUDE_DIRS})
endif()

if(NO_GBM)
    add_definitions(-DNO_GBM)
endif()

#NOX11
if(USE_CLOCK)
    add_definitions(-DUSE_CLOCK)
endif()

if(NO_LOADER)
    add_definitions(-DNO_LOADER)
endif()

if(NO_INIT_CONSTRUCTOR)
    add_definitions(-DNO_INIT_CONSTRUCTOR)
endif()

#DEFAULT_ES=2
if(DEFAULT_ES EQUAL 2)
    add_definitions(-DDEFAULT_ES=2)
endif()
if(DEFAULT_ES EQUAL 1)
    add_definitions(-DDEFAULT_ES=1)
endif()
if(USE_CCACHE)
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    endif()
endif()

link_directories(${CMAKE_SOURCE_DIR}/lib)
add_definitions(-std=gnu11 -funwind-tables -fvisibility=hidden)

if (CMAKE_CC_COMPILER_ID MATCHES "Clang" OR CMAKE_SYSTEM_NAME MATCHES "Emscripten")
    add_definitions(-Wno-pointer-sign -Wno-dangling-else)
endif()

include_directories(include)
add_subdirectory(src)

enable_testing()

macro(create_test test_name test_filename calls_count tolerance)
    if (${ARGC} EQUAL 5)
        add_test(${test_name}
            ${CMAKE_COMMAND}
            -D LIBRARY_FOLDER=${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
            -D TESTS_DIRECTORY=${CMAKE_SOURCE_DIR}/tests
            -D TEST_FILENAME=${test_filename}
            -D CALLS=${calls_count}
            -D TOLERANCE=${tolerance}
            -D EXTRACT_RANGE=${ARGV4}
            -P ${CMAKE_SOURCE_DIR}/test.cmake)
    elseif (${ARGC} EQUAL 6)
        if (${ARGV4} STREQUAL "NOEXTRACT_RANGE")
            add_test(${test_name}
                ${CMAKE_COMMAND}
                -D LIBRARY_FOLDER=${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
                -D TESTS_DIRECTORY=${CMAKE_SOURCE_DIR}/tests
                -D TEST_FILENAME=${test_filename}
                -D CALLS=${calls_count}
                -D TOLERANCE_GLES1=${tolerance}
                -D TOLERANCE_GLES2=${ARGV5}
                -P ${CMAKE_SOURCE_DIR}/test.cmake)
        else (${ARGV4} STREQUAL "NOEXTRACT_RANGE")
            add_test(${test_name}
                ${CMAKE_COMMAND}
                -D LIBRARY_FOLDER=${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
                -D TESTS_DIRECTORY=${CMAKE_SOURCE_DIR}/tests
                -D TEST_FILENAME=${test_filename}
                -D CALLS=${calls_count}
                -D TOLERANCE_GLES1=${tolerance}
                -D TOLERANCE_GLES2=${ARGV5}
                -D EXTRACT_RANGE=${ARGV4}
                -P ${CMAKE_SOURCE_DIR}/test.cmake)
        endif (${ARGV4} STREQUAL "NOEXTRACT_RANGE")
    else (${ARGC} EQUAL 5)
        add_test(${test_name}
            ${CMAKE_COMMAND}
            -D LIBRARY_FOLDER=${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
            -D TESTS_DIRECTORY=${CMAKE_SOURCE_DIR}/tests
            -D TEST_FILENAME=${test_filename}
            -D CALLS=${calls_count}
            -D TOLERANCE=${tolerance}
            -P ${CMAKE_SOURCE_DIR}/test.cmake)
    endif (${ARGC} EQUAL 5)
endmacro(create_test)

macro(create_test_GLES test_name GLES test_filename calls_count tolerance)
    if (${ARGC} EQUAL 5)
        add_test(${test_name}_GLES${GLES}
            ${CMAKE_COMMAND}
            -D LIBRARY_FOLDER=${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
            -D TESTS_DIRECTORY=${CMAKE_SOURCE_DIR}/tests
            -D TEST_FILENAME=${test_filename}
            -D CALLS=${calls_count}
            -D TOLERANCE=${tolerance}
            -D EXTRACT_RANGE=${ARGV4}
            -D GLES_FORCED=${GLES}
            -P ${CMAKE_SOURCE_DIR}/test.cmake)
    else (${ARGC} EQUAL 5)
        add_test(${test_name}_GLES${GLES}
            ${CMAKE_COMMAND}
            -D LIBRARY_FOLDER=${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
            -D TESTS_DIRECTORY=${CMAKE_SOURCE_DIR}/tests
            -D TEST_FILENAME=${test_filename}
            -D CALLS=${calls_count}
            -D TOLERANCE=${tolerance}
            -D GLES_FORCED=${GLES}
            -P ${CMAKE_SOURCE_DIR}/test.cmake)
    endif (${ARGC} EQUAL 5)
endmacro(create_test_GLES)

create_test(GLXgears glxgears "0000008203" 25 "NOEXTRACT_RANGE" 700)
create_test(StuntCarRacer stuntcarracer "0000118817" 20 "638x478+1+1")
create_test(Neverball neverball "0000078750" 20 "798x478+1+1" 200)
create_test(FoobillardPlus foobillardplus "0000014748" 50 "798x478+1+1" 60)
create_test(Descent3 descent3 "0000284192" 20 "638x478+1+1")
create_test(PointSprite pointsprite "0000248810" 20)

#create_test_GLES(Neverball 2 neverball "0000078750" 200 "798x478+1+1")
create_test_GLES(OpenRA 2 openra "0000031249" 20 "638x478+1+1")
create_test_GLES(GLSL_lighting 2 glsl_lighting "0000505393" 20)

=== src/CMakeLists.txt ===
include_directories(util)

#file(GLOB_RECURSE GL_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/gl/*.c)
SET(GL_SRC
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/arbconverter.c
	${CMAKE_CURRENT_SOURCE_DIR}/gl/arbgenerator.c
	${CMAKE_CURRENT_SOURCE_DIR}/gl/arbhelper.c
	${CMAKE_CURRENT_SOURCE_DIR}/gl/arbparser.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/array.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/blit.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/blend.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/buffers.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/build_info.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/debug.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/decompress.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/depth.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/directstate.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/drawing.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/enable.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/envvars.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/eval.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/face.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/fog.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/fpe.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/fpe_cache.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/fpe_shader.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/framebuffers.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/gl_lookup.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/getter.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/gl4es.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/glstate.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/hint.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/init.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/light.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/line.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/list.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/listdraw.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/listrl.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/loader.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/logs.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/matrix.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/matvec.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/oldprogram.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/pixel.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/planes.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/pointsprite.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/preproc.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/program.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/queries.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/raster.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/render.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/samplers.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/shader.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/shaderconv.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/shader_hacks.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/stack.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/stencil.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/string_utils.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/stubs.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/texenv.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/texgen.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/texture.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/texture_compressed.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/texture_params.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/texture_read.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/texture_3d.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/uniform.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/vertexattrib.c
	${CMAKE_CURRENT_SOURCE_DIR}/gl/wrap/gl4eswraps.c
	${CMAKE_CURRENT_SOURCE_DIR}/gl/wrap/gles.c
	${CMAKE_CURRENT_SOURCE_DIR}/gl/wrap/glstub.c
	${CMAKE_CURRENT_SOURCE_DIR}/gl/math/matheval.c
)

SET(GL_H
    ${CMAKE_CURRENT_SOURCE_DIR}/../version.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/arbconverter.h
	${CMAKE_CURRENT_SOURCE_DIR}/gl/arbgenerator.h
	${CMAKE_CURRENT_SOURCE_DIR}/gl/arbhelper.h
	${CMAKE_CURRENT_SOURCE_DIR}/gl/arbparser.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/array.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/blend.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/blit.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/buffers.h
	${CMAKE_CURRENT_SOURCE_DIR}/gl/build_info.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/const.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/debug.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/decompress.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/depth.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/directstate.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/envvars.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/eval.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/face.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/fog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/fpe.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/fpe_shader.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/framebuffers.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/gl_lookup.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/gles.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/gl4es.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/glstate.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/hint.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/init.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/light.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/line.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/list.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/loader.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/logs.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/matrix.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/matvec.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/oldprogram.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/pixel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/planes.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/pointsprite.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/preproc.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/program.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/queries.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/raster.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/render.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/samplers.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/shader.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/shaderconv.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/shader_hacks.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/stack.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/state.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/stencil.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/stb_dxt_104.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/string_utils.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/texenv.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/texgen.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/uniform.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/texture.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/vertexattrib.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/math/eval.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/wrap/gl4es.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/wrap/gles.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gl/wrap/stub.h
)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT NO_LOADER)
    include_directories(glx)
#    aux_source_directory(glx GLX_SOURCES)
#    list(APPEND GL_SOURCES ${GLX_SOURCES})
    list(APPEND GL_SRC
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/hardext.c
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/gbm.c
	    ${CMAKE_CURRENT_SOURCE_DIR}/glx/glx.c
	    ${CMAKE_CURRENT_SOURCE_DIR}/glx/lookup.c
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/rpi.c
	    ${CMAKE_CURRENT_SOURCE_DIR}/glx/streaming.c
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/utils.c
    )
    list(APPEND GL_H
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/glx_gbm.h
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/gbmfunc.h
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/drmfunc.h
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/glx.h
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/hardext.h
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/rpi.h
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/streaming.h
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/utils.h
    )
else()
    include_directories(glx)
    list(APPEND GL_SRC
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/hardext.c
    )
    message(STATUS "Not on Linux: building without GLX support.")
endif()

if(AMIGAOS4)
    include_directories(agl)
    list(APPEND GL_SRC
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/gbm.c
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/glx.c
        ${CMAKE_CURRENT_SOURCE_DIR}/agl/lookup.c
        ${CMAKE_CURRENT_SOURCE_DIR}/agl/amigaos.c
        ${CMAKE_CURRENT_SOURCE_DIR}/agl/agl.c
    )
    list(APPEND GL_H
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/hardext.h
        ${CMAKE_CURRENT_SOURCE_DIR}/glx/glx.h
        ${CMAKE_CURRENT_SOURCE_DIR}/agl/amigaos.h
        ${CMAKE_CURRENT_SOURCE_DIR}/agl/agl.h
    )
endif()

set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/gl/build_info.c PROPERTIES OBJECT_DEPENDS "${GL_SRC};${GL_H}")

if(STATICLIB)
    add_library(GL STATIC ${GL_SRC})
else()
    add_library(GL SHARED ${GL_SRC})
    
    if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
        if(NOX11)
            if(AMIGAOS4)
                target_link_libraries(GL m)
            else()
                target_link_libraries(GL m dl)
            endif()
        else()
            target_link_libraries(GL X11 m dl)
        endif()
    endif()
    if(USE_CLOCK)
        target_link_libraries(GL rt)
    endif()
    if(ANDROID)
        target_link_libraries(GL ${log-lib})
    endif()
    
    if(CMAKE_SHARED_LIBRARY_SUFFIX MATCHES ".so")
        set_target_properties(GL PROPERTIES SUFFIX ".so.1")
    endif()
    install(TARGETS GL
      LIBRARY
      DESTINATION "/usr/lib/gl4es/"
    )
    install(FILES "../include/gl4esinit.h" "../include/gl4eshint.h"
      DESTINATION "/usr/include/gl4es/"
    )
endif()

=== debian/changelog ===
gl4es (0+v1.1.4+153+gc82889c-v1.1.4+173+gef9171e) unstable; urgency=medium

  * WIP: debian: Release 0+v1.1.4+153+gc82889c-v1.1.4+173+gef9171e
    (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Wed, 03 Feb 2021 00:50:49 +0100

gl4es (0+v1.1.4+153+gc82889c-v1.1.4+171+g67f716c) unstable; urgency=medium

  * WIP: debian: Release 0+v1.1.4+153+gc82889c-v1.1.4+171+g67f716c
    (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Wed, 03 Feb 2021 00:38:55 +0100

gl4es (0.v1.1.4+4+g68cd0cc-16) unstable; urgency=medium

  * debian: WIP: Release 0.v1.1.4+4+g68cd0cc-16 (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Wed, 01 Jul 2020 10:15:18 +0200

gl4es (0.v1.1.4+4+g68cd0cc-13) unstable; urgency=medium

  * debian: WIP: Release 0.v1.1.4+4+g68cd0cc-13 (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Wed, 01 Jul 2020 09:58:08 +0200

gl4es (0.v1.1.4+4+g68cd0cc-11) unstable; urgency=medium

  * debian: WIP: Release 0.v1.1.4+4+g68cd0cc-11 (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Wed, 01 Jul 2020 09:53:54 +0200

gl4es (0.v1.1.4+4+g68cd0cc-9) unstable; urgency=medium

  * debian: WIP: Release 0.v1.1.4+4+g68cd0cc-9 (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Wed, 01 Jul 2020 09:44:10 +0200

gl4es (0.v1.1.4+3+g68d5221-5) unstable; urgency=medium

  * debian: WIP: Release 0.v1.1.4+3+g68d5221-5 (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Wed, 01 Jul 2020 08:53:01 +0200

gl4es (0.v1.1.4+3+g68d5221-3) unstable; urgency=medium

  * debian: WIP: Release 0.v1.1.4+3+g68d5221-3 (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Tue, 30 Jun 2020 23:20:13 +0200

gl4es (0.0.0-0) unstable; urgency=medium

  * wip:
    https://launchpad.net/~rzr/+archive/ubuntu/snapshot/+packages#${pack
    age}

 -- Philippe Coval <rzr@users.sf.net>  Tue, 30 Jun 2020 23:19:15 +0200

gl4es (0.0.0-1) unstable; urgency=medium

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- Philippe Coval <rzr@users.sf.net>  Fri, 19 Jun 2020 01:41:21 +0200

=== debian/control ===
Source: gl4es
Priority: optional
Maintainer: Philippe Coval <rzr@users.sf.net>
Build-Depends: debhelper-compat (= 12),
	       cmake,
	       libdrm-dev,
	       libegl-dev | libglvnd-dev,
	       libgbm-dev,
	       libx11-dev,
	       pkg-config
Standards-Version: 4.4.1
Section: libs
Homepage: https://github.com/ptitSeb/gl4es/
#Vcs-Browser: https://salsa.debian.org/debian/gl4es
#Vcs-Git: https://salsa.debian.org/debian/gl4es.git

Package: gl4es-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: gl4es0 (= ${binary:Version}), ${misc:Depends}
Description: <insert up to 60 chars description>
 <insert long description, indented with spaces>

Package: gl4es0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GL4ES - OpenGL for GLES Hardware
 <insert long description, indented with spaces>

Package: gl4es-snapshot
Architecture: all
Section: utils
Depends: ${misc:Depends}, gl4es (= ${source:Version})
Suggests: rzr
Priority: extra
Description: unreleased snapshot version
 TODO: Remove on issue and upgrade gl4es

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
-DCMAKE_VERBOSE_MAKEFILE=ON \
-DGBM=ON \
-DNOX11=ON \
# EOL


override_dh_auto_test:
	echo "# TODO: $@"

## gl4es 1.1.4%2B1gitb086fb1c

=== debian/changelog ===
gl4es (1.1.4+1gitb086fb1c) unstable; urgency=medium

  * Use git version
    - commit b086fb1c95cedab97243c221e5c31c5a67b2b59b
  * trans format 3.0 (quilt) to 3.0 (native)

 -- Han Gao <gaohan@iscas.ac.cn>  Sun, 08 Oct 2023 22:20:52 +0800

gl4es (1.1.4-1) unstable; urgency=medium

  * Initial release 

 -- licheng <shiptux@gmail.com>  Fri, 30 Jul 2021 14:53:15 +0800

## gl4es 1.1.4%2B2git3d41822f

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,13 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 2.8.12)
 
 project(gl4es LANGUAGES C)
 
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/lib)
 set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/lib)
+
+set(CMAKE_SKIP_INSTALL_RPATH ON)
+set(CMAKE_SKIP_RPATH ON)
 
 link_directories(${CMAKE_LIBRARY_OUTPUT_DIRECTORY})
 
@@ -12,6 +15,7 @@
 option(PYRA "Set to ON if targeting an Dragonbox Pyra device" ${PYRA})
 option(BCMHOST "Set to ON if targeting an RPi(2) device" ${BCMHOST})
 option(ODROID "Set to ON if targeting an ODroid device" ${ODROID})
+option(GOA_CLONE "Set to ON if targeting GO Advance clones, like RG351p/v, Gameforce Chi, RGB10..." ${GOA_CLONE})
 option(ANDROID "Set to ON if targeting an Android device" ${ANDROID})
 option(CHIP "Set to ON if targeting an C.H.I.P. device" ${CHIP})
 option(AMIGAOS4 "Set to ON if targeting an AmigaOS4/Warp3D platform (activate NOEGL and NOX11)" ${AMIGAOS4})
@@ -23,11 +27,23 @@
 option(USE_CLOCK "Set to ON to use clock_gettime instead of gttimeofday for LIBGL_FPS" ${USE_CLOCK})
 option(NO_LOADER "disable library loader (useful for static library with NOEGL, NOX11, use include/gl4esinit.h)" ${NO_LOADER})
 option(NO_INIT_CONSTRUCTOR "disable automatic initialization (useful for static library, use include/gl4esinit.h)" ${NO_INIT_CONSTRUCTOR})
+option(USE_ANDROID_LOG "Set to ON to use Android log instead of stdio" ${USE_ANDROID_LOG})
+option(EGL_WRAPPER "Set to ON to build EGL wrapper" ${EGL_WRAPPER})
+option(GLX_STUBS "Set to ON to build GLX function stubs" ${GLX_STUBS})
 
 include(CheckSymbolExists)
 check_symbol_exists(backtrace "execinfo.h" HAS_BACKTRACE)
 if (HAS_BACKTRACE)
     add_definitions(-DHAS_BACKTRACE)
+endif()
+
+if(CMAKE_SYSTEM_NAME MATCHES "Windows" OR CMAKE_SYSTEM_NAME MATCHES "MSYS")
+    set(NOX11 ON)
+    set(NO_GBM ON)
+    set(WIN32_PLATFORM ON)
+    if(CMAKE_C_COMPILER_ID MATCHES "MSVC" OR "x${CMAKE_C_SIMULATE_ID}" STREQUAL "xMSVC")
+        set(WIN32_MSVC ON)  #msvc or icl or clang-cl
+    endif()
 endif()
 
 # Pandora
@@ -60,6 +76,7 @@
 # Pyra
 if(PYRA)
     add_definitions(-DPYRA)
+    set(USE_CLOCK ON)
     #add_definitions(-DTEXSTREAM)
     add_definitions(-mcpu=cortex-a15 -mfpu=neon-vfpv4 -mfloat-abi=hard -ftree-vectorize -fsingle-precision-constant -ffast-math)
     set(NO_GBM ON)
@@ -77,10 +94,22 @@
     add_definitions(-DODROID)
 endif()
 
+# GOA_CLONE
+if(GOA_CLONE)
+    add_definitions(-DGOA_CLONE)
+    add_definitions(-mcpu=cortex-a35 -mfpu=neon-vfpv3 -march=armv8-a+crc+simd+crypto -mfloat-abi=hard -ftree-vectorize -fsingle-precision-constant -ffast-math)
+    set(EGL_WRAPPER ON)
+    set(GLX_STUBS ON)
+endif()
+
 # Android
 if(ANDROID)
     add_definitions(-DANDROID)
     add_definitions(-DNOX11 -DNO_GBM -DDEFAULT_ES=2)
+endif()
+
+if(USE_ANDROID_LOG)
+    add_definitions(-DUSE_ANDROID_LOG)
     find_library(log-lib log)
 endif()
 
@@ -141,6 +170,10 @@
     add_definitions(-DNO_INIT_CONSTRUCTOR)
 endif()
 
+if(GLX_STUBS)
+    add_definitions(-DGLX_STUBS)
+endif()
+
 #DEFAULT_ES=2
 if(DEFAULT_ES EQUAL 2)
     add_definitions(-DDEFAULT_ES=2)
@@ -157,7 +190,26 @@
 endif()
 
 link_directories(${CMAKE_SOURCE_DIR}/lib)
-add_definitions(-std=gnu11 -funwind-tables -fvisibility=hidden)
+if(NOT WIN32_MSVC)
+    add_definitions(-std=gnu11 -funwind-tables)
+    if(NOT WIN32_PLATFORM)
+       add_definitions(-fvisibility=hidden)
+    else()
+       set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--exclude-all-symbols,--kill-at")
+    endif()
+elseif(CMAKE_C_COMPILER_ID MATCHES "Clang")
+    add_definitions(-Wno-deprecated-declarations) #strdup
+    add_definitions(-Wno-unused-function -Wno-unused-variable -Wno-dangling-else)
+    add_definitions(-Wno-implicit-const-int-float-conversion)
+    add_definitions(-Wno-visibility)
+else()
+    if(CMAKE_C_COMPILER_ID MATCHES "Intel")
+        add_definitions(-wd1786 -wd589 -wd537 -wd118 -wd2722)
+    else()
+        add_definitions(-wd4996 -wd4244 -wd4267 -wd4098 -wd4018)
+    endif()
+    add_definitions("-Dinline=__inline" "-D__func__=__FUNCTION__") # for VC<=13
+endif()
 
 if (CMAKE_CC_COMPILER_ID MATCHES "Clang" OR CMAKE_SYSTEM_NAME MATCHES "Emscripten")
     add_definitions(-Wno-pointer-sign -Wno-dangling-else)

=== debian/changelog ===
gl4es (1.1.4+2git3d41822f) unstable; urgency=medium

  * Use git version
    - commit 3d41822f67cde06b62cf2e4598a86d8aa0390fc0
  * trans format 3.0 (quilt) to 3.0 (native)

 -- Han Gao <gaohan@iscas.ac.cn>  Sun, 08 Oct 2023 22:20:52 +0800

=== debian/control ===
Source: gl4es
Section: libs
Priority: optional
Maintainer: licheng <shiptux@gmail.com>
Build-Depends: debhelper (>= 11), cmake, libx11-dev, dh-exec
Standards-Version: 4.6.2
Homepage: https://github.com/ptitSeb/gl4es

Package: libgl4es
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-arch: no
Description: GL4ES - OpenGL for GLES Hardware
 This is a library provide OpenGL 2.x functionality for GLES2.0 accelerated Hardware
 (and of course also support OpenGL 1.5 function, so metimes better than when using
 GLES 1.1 backend) There is also support for GLES 1.1 Hardware, emulating OpenGL 1.5,
 and some OpenGL 2.x + extensions.
 This package contains the shared libraries.

Package: libgl4es-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-arch: no
Description: GL4ES - OpenGL for GLES Hardware
 This is a headers provide OpenGL 2.x functionality for GLES2.0 accelerated Hardware
 (and of course also support OpenGL 1.5 function, so metimes better than when using
 GLES 1.1 backend) There is also support for GLES 1.1 Hardware, emulating OpenGL 1.5,
 and some OpenGL 2.x + extensions.
 This package contains the development files.

## gl4es 1.1.6+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,9 +5,6 @@
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/lib)
 set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/lib)
-
-set(CMAKE_SKIP_INSTALL_RPATH ON)
-set(CMAKE_SKIP_RPATH ON)
 
 link_directories(${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -145,6 +145,7 @@
         ${CMAKE_CURRENT_SOURCE_DIR}/glx/hardext.c
         ${CMAKE_CURRENT_SOURCE_DIR}/glx/gbm.c
 	    ${CMAKE_CURRENT_SOURCE_DIR}/glx/glx.c
+	    ${CMAKE_CURRENT_SOURCE_DIR}/glx/glx_stubs.c
 	    ${CMAKE_CURRENT_SOURCE_DIR}/glx/lookup.c
         ${CMAKE_CURRENT_SOURCE_DIR}/glx/rpi.c
 	    ${CMAKE_CURRENT_SOURCE_DIR}/glx/streaming.c
@@ -187,7 +188,16 @@
 
 set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/gl/build_info.c PROPERTIES OBJECT_DEPENDS "${GL_SRC};${GL_H}")
 
-if(STATICLIB)
+if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
+    if(STATICLIB)
+        add_library(OPENGL32 STATIC ${GL_SRC})
+    else()
+        add_library(OPENGL32 SHARED ${GL_SRC})
+        # some ES simulators used opengl32.dll :(
+        set_target_properties(OPENGL32 PROPERTIES OUTPUT_NAME "GL32")
+        set_target_properties(OPENGL32 PROPERTIES IMPORT_PREFIX "OPEN")
+    endif()
+elseif(STATICLIB)
     add_library(GL STATIC ${GL_SRC})
 else()
     add_library(GL SHARED ${GL_SRC})
@@ -206,7 +216,7 @@
     if(USE_CLOCK)
         target_link_libraries(GL rt)
     endif()
-    if(ANDROID)
+    if(USE_ANDROID_LOG)
         target_link_libraries(GL ${log-lib})
     endif()
     
@@ -221,3 +231,25 @@
       DESTINATION "/usr/include/gl4es/"
     )
 endif()
+
+
+SET(EGL_SRC
+    ${CMAKE_CURRENT_SOURCE_DIR}/egl/egl.c
+    ${CMAKE_CURRENT_SOURCE_DIR}/egl/lookup.c
+)
+
+SET(EGL_H
+    ${CMAKE_CURRENT_SOURCE_DIR}/egl/egl.h
+)
+
+if(EGL_WRAPPER)
+    add_library(EGL SHARED ${EGL_SRC})
+    target_link_libraries(EGL GL dl)
+    if(USE_ANDROID_LOG)
+        target_link_libraries(EGL ${log-lib})
+    endif()
+    if(CMAKE_SHARED_LIBRARY_SUFFIX MATCHES ".so")
+        set_target_properties(EGL PROPERTIES SUFFIX ".so.1")
+    endif()
+endif()
+

=== debian/changelog ===
gl4es (1.1.6+ds-2) unstable; urgency=medium

  * update autopkgtest. (Closes: #1072549)

 -- Bo YU <tsu.yubo@gmail.com>  Thu, 06 Jun 2024 14:55:41 +0800

gl4es (1.1.6+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1035566)

 -- Bo YU <tsu.yubo@gmail.com>  Fri, 30 Jul 2021 14:53:15 +0800

=== debian/control ===
Source: gl4es
Section: libs
Priority: optional
Maintainer: Bo YU <tsu.yubo@gmail.com>
Uploaders:
 licheng <shiptux@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 debhelper (>= 11),
 cmake,
 libx11-dev,
Standards-Version: 4.7.0
Homepage: https://github.com/ptitSeb/gl4es
Vcs-Git: https://salsa.debian.org/vimerbf-guest/gl4es.git
Vcs-Browser: https://salsa.debian.org/vimerbf-guest/gl4es
Rules-Requires-Root: no

Package: libgl4es0
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: GL4ES - OpenGL for GLES Hardware -- runtime library
 This is a library provide OpenGL 2.x functionality for GLES2.0 accelerated
 Hardware (and of course also support OpenGL 1.5 function, so metimes better
 than when using GLES 1.1 backend) There is also support for GLES 1.1 Hardware,
 emulating OpenGL 1.5, and some OpenGL 2.x + extensions.
 .
 This package contains the shared libraries.

Package: libgl4es-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgl4es0 (= ${binary:Version}),
Description: GL4ES - OpenGL for GLES Hardware -- development files
 This is a headers provide OpenGL 2.x functionality for GLES2.0 accelerated
 Hardware (and of course also support OpenGL 1.5 function, so metimes better
 than when using GLES 1.1 backend) There is also support for GLES 1.1 Hardware,
 emulating OpenGL 1.5, and some OpenGL 2.x + extensions.
 .
 This package contains the development files.

=== debian/tests/control ===
Tests: link
Depends: libgl4es0, libgl4es-dev, gcc, libc-bin, libc6-dev 
Restrictions: allow-stderr, needs-root

=== debian/watch ===
version=4

opts="dversionmangle=s/\+ds\d*$//, \
   repacksuffix=+ds, repack, \
   filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/ptitSeb/gl4es/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
